#include <stdio.h>
#include <stdlib.h>
#include <math.h>

extern void dgemm_(char* TRANSA, char* TRANSB, int* M,int *N, int *K, double* ALPHA, double* A,int* LDA, double* B, int* LDB, double* BETA, double*C, int* LDC);

int main(int argc, char **argv)
{
   int n = 500;
   double a[n][n], b[n][n], c[n][n], d[n][n];
   int i, j, k;

   for (i=0; i<n; i++) 
      for (j=0; j<n; j++) {
         a[i][j] = ((double)rand())/((double)RAND_MAX);
         b[i][j] = ((double)rand())/((double)RAND_MAX);
         c[i][j] = 0.0;
      }


   for (i=0; i<n; i++) 
      for (k=0; k<n; k++)  
         for (j=0; j<n; j++) 
            c[i][j] += a[i][k]*b[k][j];

   double alpha =1.0;
   double beta =0.0;
   dgemm_("T", "T",  &n, &n, &n, &alpha, &a[0][0], &n, &b[0][0], &n, &beta, &d[0][0], &n);

   double maxd = 0.0;
   for (i=0; i<n; i++)
      for (j=0; j<n; j++)
         maxd = fmax(maxd, fabs(c[i][j]-d[j][i]));

   printf("%18.9lE\n", maxd);

   return 0;

}
   

 
